/*#######################################################################################
SPI_LCD with HD44780 LCD controller

Copyright (C) 2005 Branko Golubovic
branko.golubovic@gmx.at
#######################################################################################*/

#include "main.h"

int main (void)
//############################################################################
{
 unsigned char  Buffer[LCD_COLUMNS+1],Keys,Key_flag=0,Key_counter=0;
 signed int Counter=0;
 
	IO_init();
	spi_init();		
	timer0_init();	
	spi_lcd_init(LCD_COLUMNS);
	leds=(1<<BG_LIGHT);		// Background Light on
	spi_lcd_leds(leds);
	// Show Ram and Flash String
	spi_lcd_puts("SRAM String");
	spi_lcd_gotoxy(0,1);
	spi_lcd_puts_p(PSTR("FLASH String"));
	spi_lcd_gotoxy(0,2);
	spi_lcd_puts("TIME:");
	spi_lcd_gotoxy(0,3);
	spi_lcd_puts("Counter:");
	itoa(Counter,Buffer,10);
	spi_lcd_puts(Buffer);
	// Enable Interrupt
	sei();
	
	while(1)	// Infinite Loop
	{ 
		//Keys Update
		if(syncbute & (1<<KEYSYNC))
		{ 
			syncbute&=~(1<<KEYSYNC);	// Reset KEYSYNC Flag
			Keys=spi_lcd_keys();
			if(Keys)	// Key Pressed?
			{
				Key_counter++;
				if(Key_counter==KEY_EDGE) 
				{
				Key_flag|=(1<<KEYPRESS);	// First Edge
				}
				if(Key_counter==KEY_TIME)
				{
					Key_flag|=(1<<KEYPRESS);
					Key_counter-=KEY_REPEAT_TIME;					
				}
				
				
			}
			else
			{
				Key_counter=0;
			}
			// Keys Use
			if(Key_flag & (1<<KEYPRESS))
			{
				Key_flag&=~(1<<KEYPRESS);	// Reset KEYPRESS Flag
				
				switch(Keys)
				{
					case UP:		Counter++;
											break;
					case DOWN:	Counter--;
											break;
					case RESET:	Counter=0;
											break;
				}
				spi_lcd_gotoxy(8,3);
				itoa(Counter,Buffer,10);
				spi_lcd_puts(Buffer);
				spi_lcd_puts("   ");				
			}
			
		}
			
			if(syncbute & (1<<CLOCKSYNC))
			{	
				syncbute&=~(1<<CLOCKSYNC);	// Reset CLOCKSYNC Flag
				// Show Time to LCD (x,y)
				show_time(6,2);
			}
	}

return (1);
}